#ifndef Py_JIT_API_H
#define Py_JIT_API_H 1
#ifdef __cplusplus
extern "C" {
#if 0
} /* satisfy cc-mode */
#endif
#endif

#define PYJIT_VERSION "1.0a1/py"

#define PYJIT_XTL_VERSION "CrossTwine Linker " PYJIT_VERSION

typedef struct {
        unsigned disabled:1;
        unsigned verbose_compile:1;
        unsigned dump_asm:1;
        unsigned verbose;
        FILE *verbose_output;
} PyJIT_GlobalOptions;

extern PyJIT_GlobalOptions PyJIT_options;

PyAPI_FUNC(void) PyJIT_Init(void);
PyAPI_FUNC(void) PyJIT_Fini(void);

PyAPI_FUNC(int) PyJIT_Install(PyCodeObject *code);
PyAPI_FUNC(PyObject *) PyJIT_ExecFrame(PyJITCode *jit_code, PyObject *frame);
PyAPI_FUNC(int) PyJIT_Uninstall(PyCodeObject *code);

PyAPI_FUNC(int) PyJIT_NotifyTracing(PyThreadState *tstate, int active);
PyAPI_FUNC(void) PyJIT_NotifyGarbageCollection(int forced);

enum PyJIT_Flags {
        PYJIT_CONTINUE_EVAL = 1 << 0,

        PYJIT_FLAG_MASK = 0x3
};

#ifdef __cplusplus
#if 0
{ /* satisfy cc-mode */
#endif
}
#endif
#endif /* Py_JIT_API_H */
